diff -ru extract/pidgin-2.10.9/libpurple/prefs.c libpurple/prefs.c
--- extract/pidgin-2.10.9/libpurple/prefs.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/prefs.c	2015-05-04 13:42:04.500970477 +0200
@@ -1390,8 +309,6 @@
 {
 	void *handle = purple_prefs_get_handle();
 
-	prefs_hash = g_hash_table_new_full(g_str_hash, g_str_equal, g_free, NULL);
-
 	purple_prefs_connect_callback(handle, "/", prefs_save_cb, NULL);
 
 	purple_prefs_add_none("/purple");
@@ -1402,34 +319,7 @@
 
 	/* Away */
 	purple_prefs_add_none("/purple/away");
-	purple_prefs_add_string("/purple/away/idle_reporting", "system");
-	purple_prefs_add_bool("/purple/away/away_when_idle", TRUE);
-	purple_prefs_add_int("/purple/away/mins_before_away", 5);
-
-	/* Away -> Auto-Reply */
-	if (!purple_prefs_exists("/purple/away/auto_response/enabled") ||
-	    !purple_prefs_exists("/purple/away/auto_response/idle_only"))
-	{
-		purple_prefs_add_string("/purple/away/auto_reply", "awayidle");
-	}
-	else
-	{
-		if (!purple_prefs_get_bool("/purple/away/auto_response/enabled"))
-		{
-			purple_prefs_add_string("/purple/away/auto_reply", "never");
-		}
-		else
-		{
-			if (purple_prefs_get_bool("/purple/away/auto_response/idle_only"))
-			{
-				purple_prefs_add_string("/purple/away/auto_reply", "awayidle");
-			}
-			else
-			{
-				purple_prefs_add_string("/purple/away/auto_reply", "away");
-			}
-		}
-	}
+	purple_prefs_add_string("/purple/away/auto_reply", "awayidle");
 
 	/* Buddies */
 	purple_prefs_add_none("/purple/buddies");
@@ -1442,7 +332,6 @@
 	purple_prefs_remove("/purple/contact/idle_score");
 
 	purple_prefs_load();
-	purple_prefs_update_old();
 }
 
 void
@@ -1451,15 +340,22 @@
 	if (save_timer != 0)
 	{
 		purple_timeout_remove(save_timer);
-		save_timer = 0;
-		sync_prefs();
+		save_cb(NULL);
 	}
 
 	purple_prefs_disconnect_by_handle(purple_prefs_get_handle());
 
 	prefs_loaded = FALSE;
-	purple_prefs_destroy();
-	g_hash_table_destroy(prefs_hash);
-	prefs_hash = NULL;
+}
 
+void
+purple_prefs_set_ui_ops(PurplePrefsUiOps *ops)
+{
+	prefs_ui_ops = ops;
+}
+
+PurplePrefsUiOps *
+purple_prefs_get_ui_ops(void)
+{
+	return prefs_ui_ops;
 }
diff -ru extract/pidgin-2.10.9/libpurple/prefs.h libpurple/prefs.h
--- extract/pidgin-2.10.9/libpurple/prefs.h	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/prefs.h	2015-05-04 13:42:04.500970477 +0200
@@ -38,6 +38,8 @@
 	PURPLE_PREF_BOOLEAN,     /**< Boolean.         */
 	PURPLE_PREF_INT,         /**< Integer.         */
 	PURPLE_PREF_STRING,      /**< String.          */
+	/* The 3 following types are unused in libpurple,
+	   and not implemented in Instantbird */
 	PURPLE_PREF_STRING_LIST, /**< List of strings. */
 	PURPLE_PREF_PATH,        /**< Path.            */
 	PURPLE_PREF_PATH_LIST    /**< List of paths.   */
@@ -62,11 +64,71 @@
 typedef void (*PurplePrefCallback) (const char *name, PurplePrefType type,
 		gconstpointer val, gpointer data);
 
+
+/** @copydoc _PurplePrefsUiOps */
+typedef struct _PurplePrefsUiOps PurplePrefsUiOps;
+
+
+/**  Prefs UI operations
+ */
+struct _PurplePrefsUiOps
+{
+	void (*add_none)(const char *name);
+	void (*add_bool)(const char *name, gboolean value);
+	void (*add_int)(const char *name, int value);
+	void (*add_string)(const char *name, const char *value);
+
+	void (*set_bool)(const char *name, gboolean value);
+	void (*set_int)(const char *name, int value);
+	void (*set_string)(const char *name, const char *value);
+
+	gboolean (*get_bool)(const char *name);
+	int (*get_int)(const char *name);
+	const char *(*get_string)(const char *name);
+
+	PurplePrefType (*get_type)(const char *name);
+	GList *(*get_children_names)(const char *name);
+
+	gboolean (*exists)(const char *name);
+	void (*remove)(const char *name);
+
+	void (*save)(void);
+
+	void *(*add_observer)(const char *name, gpointer data);
+	void (*remove_observer)(const char *name, void *observer);
+
+	void (*_purple_reserved1)(void);
+	void (*_purple_reserved2)(void);
+	void (*_purple_reserved3)(void);
+	void (*_purple_reserved4)(void);
+};
+
+
 #ifdef __cplusplus
 extern "C" {
 #endif
 
 /**************************************************************************/
+/** @name UI Registration Functions                                       */
+/**************************************************************************/
+/*@{*/
+/**
+ * Sets the UI operations structure to be used for preferences.
+ *
+ * @param ops The UI operations structure.
+ */
+void purple_prefs_set_ui_ops(PurplePrefsUiOps *ops);
+
+/**
+ * Returns the UI operations structure used for preferences.
+ *
+ * @return The UI operations structure in use.
+ */
+PurplePrefsUiOps *purple_prefs_get_ui_ops(void);
+
+/*@}*/
+
+/**************************************************************************/
 /** @name Prefs API
     Preferences are named according to a directory-like structure.
     Example: "/plugins/core/potato/is_from_idaho" (probably a boolean)    */
@@ -122,37 +184,6 @@
 void purple_prefs_add_string(const char *name, const char *value);
 
 /**
- * Add a new string list pref.
- *
- * @param name  The name of the pref
- * @param value The initial value to set
- * @note This function takes a copy of the strings in the value list. The list
- *       itself and original copies of the strings are up to the caller to
- *       free.
- */
-void purple_prefs_add_string_list(const char *name, GList *value);
-
-/**
- * Add a new path pref.
- *
- * @param name  The name of the pref
- * @param value The initial value to set
- */
-void purple_prefs_add_path(const char *name, const char *value);
-
-/**
- * Add a new path list pref.
- *
- * @param name  The name of the pref
- * @param value The initial value to set
- * @note This function takes a copy of the strings in the value list. The list
- *       itself and original copies of the strings are up to the caller to
- *       free.
- */
-void purple_prefs_add_path_list(const char *name, GList *value);
-
-
-/**
  * Remove a pref.
  *
  * @param name The name of the pref
@@ -160,44 +191,6 @@
 void purple_prefs_remove(const char *name);
 
 /**
- * Rename a pref
- *
- * @param oldname The old name of the pref
- * @param newname The new name for the pref
- */
-void purple_prefs_rename(const char *oldname, const char *newname);
-
-/**
- * Rename a boolean pref, toggling it's value
- *
- * @param oldname The old name of the pref
- * @param newname The new name for the pref
- */
-void purple_prefs_rename_boolean_toggle(const char *oldname, const char *newname);
-
-/**
- * Remove all prefs.
- */
-void purple_prefs_destroy(void);
-
-/**
- * Set raw pref value
- *
- * @param name  The name of the pref
- * @param value The value to set
- *
- * @deprecated We're not really sure what purpose this function serves, so it
- *             will be removed in 3.0.0.  Preferences values set using this
- *             function aren't serialized to prefs.xml, which could be
- *             misleading.  There is also no purple_prefs_get_generic, which
- *             means that if you can't really get the value (other in a
- *             connected callback).  If you think you have a use for this then
- *             please let us know.
- */
-/* TODO: When this is removed, also remove struct purple_pref->value.generic */
-void purple_prefs_set_generic(const char *name, gpointer value);
-
-/**
  * Set boolean pref value
  *
  * @param name  The name of the pref
@@ -221,30 +214,6 @@
  */
 void purple_prefs_set_string(const char *name, const char *value);
 
-/**
- * Set string list pref value
- *
- * @param name  The name of the pref
- * @param value The value to set
- */
-void purple_prefs_set_string_list(const char *name, GList *value);
-
-/**
- * Set path pref value
- *
- * @param name  The name of the pref
- * @param value The value to set
- */
-void purple_prefs_set_path(const char *name, const char *value);
-
-/**
- * Set path list pref value
- *
- * @param name  The name of the pref
- * @param value The value to set
- */
-void purple_prefs_set_path_list(const char *name, GList *value);
-
 
 /**
  * Check if a pref exists
@@ -287,30 +256,6 @@
 const char *purple_prefs_get_string(const char *name);
 
 /**
- * Get string list pref value
- *
- * @param name The name of the pref
- * @return The value of the pref
- */
-GList *purple_prefs_get_string_list(const char *name);
-
-/**
- * Get path pref value
- *
- * @param name The name of the pref
- * @return The value of the pref
- */
-const char *purple_prefs_get_path(const char *name);
-
-/**
- * Get path list pref value
- *
- * @param name The name of the pref
- * @return The value of the pref
- */
-GList *purple_prefs_get_path_list(const char *name);
-
-/**
  * Returns a list of children for a pref
  *
  * @param name The parent pref
@@ -338,6 +283,11 @@
 		gpointer data);
 
 /**
+ * Call the callback of the observer
+ */
+void purple_prefs_observe(gpointer data);
+
+/**
  * Remove a callback to a pref
  */
 void purple_prefs_disconnect_callback(guint callback_id);
@@ -357,11 +307,6 @@
  */
 gboolean purple_prefs_load(void);
 
-/**
- * Rename legacy prefs and delete some that no longer exist.
- */
-void purple_prefs_update_old(void);
-
 /*@}*/
 
 #ifdef __cplusplus
Only in libpurple/protocols/bonjour: Makefile.in
Only in libpurple/protocols/bonjour: moz.build
Only in libpurple/protocols/bonjour: win32
Only in libpurple/protocols: create-cid.sh
diff -ru extract/pidgin-2.10.9/libpurple/protocols/gg/lib/common.c libpurple/protocols/gg/lib/common.c
--- extract/pidgin-2.10.9/libpurple/protocols/gg/lib/common.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/gg/lib/common.c	2015-05-04 13:42:04.544970475 +0200
@@ -44,7 +44,9 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
-#include <unistd.h>
+#ifndef _MSC_VER
+#  include <unistd.h>
+#endif
 
 #include "libgadu.h"
 
diff -ru extract/pidgin-2.10.9/libpurple/protocols/gg/lib/dcc7.c libpurple/protocols/gg/lib/dcc7.c
--- extract/pidgin-2.10.9/libpurple/protocols/gg/lib/dcc7.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/gg/lib/dcc7.c	2015-05-04 13:42:04.544970475 +0200
@@ -49,7 +49,9 @@
 #include <string.h>
 #include <stdio.h>
 #include <stdlib.h>
-#include <unistd.h>
+#ifndef _MSC_VER
+#  include <unistd.h>
+#endif
 
 #include "compat.h"
 #include "libgadu.h"
@@ -58,8 +60,8 @@
 #include "libgadu-internal.h"
 #include "libgadu-debug.h"
 
-#define gg_debug_dcc(dcc, level, fmt...) \
-	gg_debug_session(((dcc) != NULL) ? (dcc)->sess : NULL, level, fmt)
+#define gg_debug_dcc(dcc, level, ...) \
+	gg_debug_session(((dcc) != NULL) ? (dcc)->sess : NULL, level, __VA_ARGS__)
 
 #define gg_debug_dump_dcc(dcc, level, buf, len) \
 	gg_debug_dump(((dcc) != NULL) ? (dcc)->sess : NULL, level, buf, len)
diff -ru extract/pidgin-2.10.9/libpurple/protocols/gg/lib/events.c libpurple/protocols/gg/lib/events.c
--- extract/pidgin-2.10.9/libpurple/protocols/gg/lib/events.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/gg/lib/events.c	2015-05-04 13:42:04.548970475 +0200
@@ -50,7 +50,9 @@
 #include <string.h>
 #include <stdlib.h>
 #include <time.h>
-#include <unistd.h>
+#ifndef _MSC_VER
+#  include <unistd.h>
+#endif
 #include <ctype.h>
 #ifdef GG_CONFIG_HAVE_GNUTLS
 #  include <gnutls/gnutls.h>
diff -ru extract/pidgin-2.10.9/libpurple/protocols/gg/lib/handlers.c libpurple/protocols/gg/lib/handlers.c
--- extract/pidgin-2.10.9/libpurple/protocols/gg/lib/handlers.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/gg/lib/handlers.c	2015-05-04 13:42:04.548970475 +0200
@@ -59,7 +59,9 @@
 #include <stdlib.h>
 #include <string.h>
 #include <signal.h>
-#include <unistd.h>
+#ifndef _MSC_VER
+#  include <unistd.h>
+#endif
 #include <time.h>
 #ifdef GG_CONFIG_HAVE_OPENSSL
 #  include <openssl/err.h>
diff -ru extract/pidgin-2.10.9/libpurple/protocols/gg/lib/http.c libpurple/protocols/gg/lib/http.c
--- extract/pidgin-2.10.9/libpurple/protocols/gg/lib/http.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/gg/lib/http.c	2015-05-04 13:42:04.548970475 +0200
@@ -45,7 +45,9 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
-#include <unistd.h>
+#ifndef _MSC_VER
+#  include <unistd.h>
+#endif
 
 #define GG_HTTP_MAX_LENGTH 1000000000
 
diff -ru extract/pidgin-2.10.9/libpurple/protocols/gg/lib/libgadu.c libpurple/protocols/gg/lib/libgadu.c
--- extract/pidgin-2.10.9/libpurple/protocols/gg/lib/libgadu.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/gg/lib/libgadu.c	2015-05-04 13:42:04.552970475 +0200
@@ -65,7 +65,9 @@
 #include <string.h>
 #include <signal.h>
 #include <time.h>
-#include <unistd.h>
+#ifndef _MSC_VER
+#  include <unistd.h>
+#endif
 #ifdef GG_CONFIG_HAVE_GNUTLS
 #  include <gnutls/gnutls.h>
 #endif
diff -ru extract/pidgin-2.10.9/libpurple/protocols/gg/lib/libgadu-config.h libpurple/protocols/gg/lib/libgadu-config.h
--- extract/pidgin-2.10.9/libpurple/protocols/gg/lib/libgadu-config.h	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/gg/lib/libgadu-config.h	2015-05-04 13:42:04.552970475 +0200
@@ -1,6 +1,6 @@
 /* Local libgadu configuration. */
 
-#include "config.h"
+/*#include "config.h" */
 
 #ifndef __GG_LIBGADU_CONFIG_H
 #define __GG_LIBGADU_CONFIG_H
@@ -11,11 +11,13 @@
 #define __GG_LIBGADU_BIGENDIAN
 #endif /* WORDS_BIGENDIAN */
 
+#ifndef _WIN32
 /* Defined if this machine has va_copy(). */
 #define __GG_LIBGADU_HAVE_VA_COPY
 
 /* Defined if this machine has __va_copy(). */
 #define __GG_LIBGADU_HAVE___VA_COPY
+#endif
 
 /* Defined if this machine supports long long. */
 #undef __GG_LIBGADU_HAVE_LONG_LONG
@@ -56,4 +58,18 @@
 #define random (long) rand
 #endif
 
+#ifdef _MSC_VER
+typedef unsigned __int32 uint32_t;
+typedef unsigned __int16 uint16_t;
+typedef unsigned __int8  uint8_t;
+#define snprintf _snprintf
+#include <win32dep.h>
+#define EINPROGRESS WSAEINPROGRESS
+#define ECONNRESET WSAECONNRESET
+#define ENOTCONN WSAENOTCONN
+#define strncasecmp strnicmp
+#define strcasecmp stricmp
+#define ssize_t SSIZE_T
+#endif
+
 #endif /* __GG_LIBGADU_CONFIG_H */
diff -ru extract/pidgin-2.10.9/libpurple/protocols/gg/lib/libgadu.h libpurple/protocols/gg/lib/libgadu.h
--- extract/pidgin-2.10.9/libpurple/protocols/gg/lib/libgadu.h	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/gg/lib/libgadu.h	2015-05-04 13:42:04.556970475 +0200
@@ -41,6 +41,8 @@
 extern "C" {
 #endif
 
+#include "libgadu-config.h"
+
 #include <sys/types.h>
 #include <stdio.h>
 #include <stdarg.h>
@@ -2288,9 +2290,11 @@
 
 #define GG_DCC7_DUNNO1 0x24
 
+#if 0
 struct gg_dcc7_dunno1 {
 	// XXX
 } GG_PACKED;
+#endif
 
 #define GG_DCC7_TIMEOUT_CONNECT 10	/* 10 sekund */
 #define GG_DCC7_TIMEOUT_SEND 1800	/* 30 minut */
diff -ru extract/pidgin-2.10.9/libpurple/protocols/gg/lib/message.h libpurple/protocols/gg/lib/message.h
--- extract/pidgin-2.10.9/libpurple/protocols/gg/lib/message.h	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/gg/lib/message.h	2015-05-04 13:42:04.556970475 +0200
@@ -20,7 +20,6 @@
 #define LIBGADU_MESSAGE_H
 
 #include <sys/types.h>
-#include <inttypes.h>
 #include "libgadu.h"
 
 #if 0
diff -ru extract/pidgin-2.10.9/libpurple/protocols/gg/lib/pubdir.c libpurple/protocols/gg/lib/pubdir.c
--- extract/pidgin-2.10.9/libpurple/protocols/gg/lib/pubdir.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/gg/lib/pubdir.c	2015-05-04 13:42:04.556970475 +0200
@@ -32,7 +32,9 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#ifndef _MSC_VER
 #include <unistd.h>
+#endif
 
 #include "libgadu.h"
 #include "libgadu-config.h"
diff -ru extract/pidgin-2.10.9/libpurple/protocols/gg/lib/resolver.c libpurple/protocols/gg/lib/resolver.c
--- extract/pidgin-2.10.9/libpurple/protocols/gg/lib/resolver.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/gg/lib/resolver.c	2015-05-04 13:42:04.556970475 +0200
@@ -33,7 +33,9 @@
 #include <errno.h>
 #include <stdlib.h>
 #include <string.h>
-#include <unistd.h>
+#ifndef _MSC_VER
+#  include <unistd.h>
+#endif
 #ifndef _WIN32
 #  include <signal.h>
 #  include <netinet/in.h>
diff -ru extract/pidgin-2.10.9/libpurple/protocols/gg/lib/sha1.c libpurple/protocols/gg/lib/sha1.c
--- extract/pidgin-2.10.9/libpurple/protocols/gg/lib/sha1.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/gg/lib/sha1.c	2015-05-04 13:42:04.560970475 +0200
@@ -28,7 +28,9 @@
 
 #include <string.h>
 #include <sys/types.h>
+#ifndef _MSC_VER
 #include <unistd.h>
+#endif
 
 #include "libgadu.h"
 
Only in libpurple/protocols/gg: Makefile.in
Only in libpurple/protocols/gg: moz.build
Only in extract/pidgin-2.10.9/libpurple/protocols: irc
Only in extract/pidgin-2.10.9/libpurple/protocols/jabber: auth_cyrus.c
diff -ru extract/pidgin-2.10.9/libpurple/protocols/jabber/disco.c libpurple/protocols/jabber/disco.c
--- extract/pidgin-2.10.9/libpurple/protocols/jabber/disco.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/jabber/disco.c	2015-05-04 13:42:04.572970474 +0200
@@ -35,7 +35,9 @@
 #include "google/jingleinfo.h"
 #include "iq.h"
 #include "jabber.h"
+#ifdef USE_JINGLE
 #include "jingle/jingle.h"
+#endif
 #include "pep.h"
 #include "presence.h"
 #include "roster.h"
diff -ru extract/pidgin-2.10.9/libpurple/protocols/jabber/iq.c libpurple/protocols/jabber/iq.c
--- extract/pidgin-2.10.9/libpurple/protocols/jabber/iq.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/jabber/iq.c	2015-05-04 13:42:04.580970474 +0200
@@ -33,7 +33,9 @@
 #include "google/jingleinfo.h"
 #include "google/google_session.h"
 #include "iq.h"
+#ifdef USE_JINGLE
 #include "jingle/jingle.h"
+#endif
 #include "oob.h"
 #include "roster.h"
 #include "si.h"
@@ -43,7 +45,7 @@
 #include "ibb.h"
 
 #ifdef _WIN32
-#include "utsname.h"
+#include "win32/utsname.h"
 #endif
 
 static GHashTable *iq_handlers = NULL;
@@ -552,7 +554,9 @@
 	iq_handlers = g_hash_table_new_full(g_str_hash, g_str_equal, g_free, NULL);
 	signal_iq_handlers = g_hash_table_new_full(g_str_hash, g_str_equal, g_free, NULL);
 
+#ifdef USE_JINGLE
 	jabber_iq_register_handler("jingle", JINGLE, jingle_parse);
+#endif
 	jabber_iq_register_handler("mailbox", NS_GOOGLE_MAIL_NOTIFY,
 			jabber_gmail_poke);
 	jabber_iq_register_handler("new-mail", NS_GOOGLE_MAIL_NOTIFY,
diff -ru extract/pidgin-2.10.9/libpurple/protocols/jabber/jabber.c libpurple/protocols/jabber/jabber.c
--- extract/pidgin-2.10.9/libpurple/protocols/jabber/jabber.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/jabber/jabber.c	2015-05-04 13:42:04.584970474 +0200
@@ -69,8 +69,10 @@
 #include "pep.h"
 #include "adhoccommands.h"
 
+#ifdef USE_JINGLE
 #include "jingle/jingle.h"
 #include "jingle/rtp.h"
+#endif
 
 #define PING_TIMEOUT 60
 /* Send a whitespace keepalive to the server if we haven't sent
@@ -1589,8 +1591,10 @@
 {
 	JabberStream *js = purple_connection_get_protocol_data(gc);
 
+#ifdef USE_JINGLE
 	/* Close all of the open Jingle sessions on this stream */
 	jingle_terminate_sessions(js);
+#endif
 
 	if (js->bosh)
 		jabber_bosh_connection_close(js->bosh);
@@ -3866,8 +3870,10 @@
 	/* Bits Of Binary */
 	jabber_add_feature(NS_BOB, 0);
 
+#ifdef USE_JINGLE
 	/* Jingle features! */
 	jabber_add_feature(JINGLE, 0);
+#endif
 
 #ifdef USE_VV
 	jabber_add_feature(NS_GOOGLE_PROTOCOL_SESSION, jabber_audio_enabled);
diff -ru extract/pidgin-2.10.9/libpurple/protocols/jabber/jabber.h libpurple/protocols/jabber/jabber.h
--- extract/pidgin-2.10.9/libpurple/protocols/jabber/jabber.h	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/jabber/jabber.h	2015-05-04 13:42:04.584970474 +0200
@@ -60,8 +60,10 @@
 #include "connection.h"
 #include "dnsquery.h"
 #include "dnssrv.h"
+#ifdef USE_VV
 #include "media.h"
 #include "mediamanager.h"
+#endif
 #include "roomlist.h"
 #include "sslconn.h"
 
diff -ru extract/pidgin-2.10.9/libpurple/protocols/jabber/libxmpp.c libpurple/protocols/jabber/libxmpp.c
--- extract/pidgin-2.10.9/libpurple/protocols/jabber/libxmpp.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/jabber/libxmpp.c	2015-05-04 13:42:04.584970474 +0200
@@ -258,11 +258,11 @@
 	GList *encryption_values = NULL;
 
 	/* Translators: 'domain' is used here in the context of Internet domains, e.g. pidgin.im */
-	split = purple_account_user_split_new(_("Domain"), NULL, '@');
+	split = purple_account_user_split_new(_("Domain"), "jabber.org", '@');
 	purple_account_user_split_set_reverse(split, FALSE);
 	prpl_info.user_splits = g_list_append(prpl_info.user_splits, split);
 
-	split = purple_account_user_split_new(_("Resource"), "", '/');
+	split = purple_account_user_split_new(_("Resource"), "Instantbird", '/');
 	purple_account_user_split_set_reverse(split, FALSE);
 	prpl_info.user_splits = g_list_append(prpl_info.user_splits, split);
 
@@ -315,13 +315,6 @@
 	prpl_info.protocol_options = g_list_append(prpl_info.protocol_options,
 						  option);
 
-	/* this should probably be part of global smiley theme settings later on,
-	  shared with MSN */
-	option = purple_account_option_bool_new(_("Show Custom Smileys"),
-		"custom_smileys", TRUE);
-	prpl_info.protocol_options = g_list_append(prpl_info.protocol_options,
-		option);
-
 	my_protocol = plugin;
 
 	purple_prefs_remove("/plugins/prpl/jabber");
Only in libpurple/protocols/jabber: Makefile.in
diff -ru extract/pidgin-2.10.9/libpurple/protocols/jabber/message.c libpurple/protocols/jabber/message.c
--- extract/pidgin-2.10.9/libpurple/protocols/jabber/message.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/jabber/message.c	2015-05-04 13:42:04.588970474 +0200
@@ -106,7 +106,8 @@
 					 * this should be able to be implemented by removing the
 					 * user from the conversation like we do with chats now. */
 					purple_conversation_write(conv, "", buf,
-					                        PURPLE_MESSAGE_SYSTEM, time(NULL));
+					                          PURPLE_MESSAGE_SYSTEM | PURPLE_MESSAGE_NO_LINKIFY,
+					                          time(NULL));
 				}
 			}
 			serv_got_typing_stopped(gc, jm->from);
@@ -602,7 +603,7 @@
 				GList *smiley_refs = NULL;
 				gchar *reformatted_xhtml;
 
-				if (purple_account_get_bool(account, "custom_smileys", TRUE)) {
+				if (purple_account_get_bool(account, "custom_smileys", FALSE)) {
 					/* find a list of smileys ("cid" and "alt" text pairs)
 					  occuring in the message */
 					smiley_refs = jabber_message_get_refs_from_xmlnode(child);
@@ -1303,5 +1304,5 @@
 	const PurpleConnection *gc = js->gc;
 	PurpleAccount *account = purple_connection_get_account(gc);
 
-	return purple_account_get_bool(account, "custom_smileys", TRUE);
+	return purple_account_get_bool(account, "custom_smileys", FALSE);
 }
Only in libpurple/protocols/jabber: moz.build
Only in libpurple/protocols: module.ver.in
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/cmdproc.c libpurple/protocols/msn/cmdproc.c
--- extract/pidgin-2.10.9/libpurple/protocols/msn/cmdproc.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/cmdproc.c	2015-05-04 13:42:04.452970479 +0200
@@ -109,22 +109,21 @@
 	g_free(show);
 }
 
-gboolean
+void
 msn_cmdproc_send_trans(MsnCmdProc *cmdproc, MsnTransaction *trans)
 {
 	MsnServConn *servconn;
 	char *data;
 	size_t len;
-	gboolean ret;
 
-	g_return_val_if_fail(cmdproc != NULL, TRUE);
-	g_return_val_if_fail(trans != NULL, TRUE);
+	g_return_if_fail(cmdproc != NULL);
+	g_return_if_fail(trans != NULL);
 
 	servconn = cmdproc->servconn;
 
 	if (!servconn->connected) {
 		msn_transaction_destroy(trans);
-		return FALSE;
+		return;
 	}
 
 	if (trans->saveable)
@@ -155,12 +154,11 @@
 		trans->payload_len = 0;
 	}
 
-	ret = msn_servconn_write(servconn, data, len) != -1;
+	msn_servconn_write(servconn, data, len);
 
 	if (!trans->saveable)
 		msn_transaction_destroy(trans);
 	g_free(data);
-	return ret;
 }
 
 void
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/cmdproc.h libpurple/protocols/msn/cmdproc.h
--- extract/pidgin-2.10.9/libpurple/protocols/msn/cmdproc.h	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/cmdproc.h	2015-05-04 13:42:04.452970479 +0200
@@ -79,7 +79,7 @@
  * @param cmdproc 	The MsnCmdProc to be used.
  * @param trans 	The MsnTransaction to be sent.
  */
-gboolean msn_cmdproc_send_trans(MsnCmdProc *cmdproc, MsnTransaction *trans);
+void msn_cmdproc_send_trans(MsnCmdProc *cmdproc, MsnTransaction *trans);
 
 /**
  * Add a transaction to the queue to be processed latter.
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/contact.c libpurple/protocols/msn/contact.c
--- extract/pidgin-2.10.9/libpurple/protocols/msn/contact.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/contact.c	2015-05-04 13:42:04.456970479 +0200
@@ -474,7 +474,7 @@
 }
 
 /*parse contact list*/
-static gboolean
+static void
 msn_parse_contact_list(MsnSession *session, xmlnode *node)
 {
 	xmlnode *fault, *faultnode;
@@ -499,14 +499,13 @@
 			if (g_str_equal(errorcode, "ABDoesNotExist")) {
 				msn_create_address_book(session);
 				g_free(errorcode);
-				return FALSE;
+				return;
 			}
 
 			g_free(errorcode);
 		}
 
 		msn_get_contact_list(session, MSN_PS_INITIAL, NULL);
-		return FALSE;
 	} else {
 		xmlnode *service;
 
@@ -515,7 +514,6 @@
 			 service; service = xmlnode_get_next_twin(service)) {
 			msn_parse_each_service(session, service);
 		}
-		return TRUE;
 	}
 }
 
@@ -536,24 +534,23 @@
 
 		purple_debug_misc("msn", "Got the contact list!\n");
 
-		if (msn_parse_contact_list(session, resp->xml)) {
+		msn_parse_contact_list(session, resp->xml);
 #ifdef MSN_PARTIAL_LISTS
-			abLastChange = purple_account_get_string(session->account,
-				"ablastChange", NULL);
-			dynamicItemLastChange = purple_account_get_string(session->account,
-				"DynamicItemLastChanged", NULL);
+		abLastChange = purple_account_get_string(session->account,
+			"ablastChange", NULL);
+		dynamicItemLastChange = purple_account_get_string(session->account,
+			"DynamicItemLastChanged", NULL);
 #endif
 
-			if (state->partner_scenario == MSN_PS_INITIAL) {
+		if (state->partner_scenario == MSN_PS_INITIAL) {
 #ifdef MSN_PARTIAL_LISTS
-				/* XXX: this should be enabled when we can correctly do partial
-				   syncs with the server. Currently we need to retrieve the whole
-				   list to detect sync issues */
-				msn_get_address_book(session, MSN_PS_INITIAL, abLastChange, dynamicItemLastChange);
+			/* XXX: this should be enabled when we can correctly do partial
+			   syncs with the server. Currently we need to retrieve the whole
+			   list to detect sync issues */
+			msn_get_address_book(session, MSN_PS_INITIAL, abLastChange, dynamicItemLastChange);
 #else
-				msn_get_address_book(session, MSN_PS_INITIAL, NULL, NULL);
+			msn_get_address_book(session, MSN_PS_INITIAL, NULL, NULL);
 #endif
-			}
 		}
 	}
 }
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/directconn.c libpurple/protocols/msn/directconn.c
--- extract/pidgin-2.10.9/libpurple/protocols/msn/directconn.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/directconn.c	2015-05-04 13:42:04.456970479 +0200
@@ -51,9 +51,6 @@
 		purple_cipher_context_destroy(context);
 	} else if (type == DC_NONCE_PLAIN) {
 		memcpy(digest, nonce, nonce_len);
-	} else {
-		nonce_hash[0] = '\0';
-		g_return_if_reached();
 	}
 
 	g_sprintf(nonce_hash,
@@ -596,9 +593,7 @@
 
 	case DC_STATE_ESTABLISHED:
 		if (packet_length) {
-			MsnP2PVersion p2p;
-			p2p = msn_slplink_get_p2p_version(dc->slplink);
-			part = msn_slpmsgpart_new_from_data(p2p, dc->in_buffer + 4, packet_length);
+			part = msn_slpmsgpart_new_from_data(dc->in_buffer + 4, packet_length);
 			if (part) {
 				msn_slplink_process_msg(dc->slplink, part);
 				msn_slpmsgpart_unref(part);
diff -ru extract/pidgin-2.10.9/libpurple/protocols/msn/msg.c libpurple/protocols/msn/msg.c
--- extract/pidgin-2.10.9/libpurple/protocols/msn/msg.c	2014-02-02 22:29:18.000000000 +0100
+++ libpurple/protocols/msn/msg.c	2015-05-04 13:42:04.464970479 +0200
@@ -135,6 +135,8 @@
 
 	msn_message_set_header(msg, "User-Agent", NULL);
 
+	msg->msnslp_message = TRUE;
+
 	msn_message_set_flag(msg, 'D');
 	msn_message_set_content_type(msg, "application/x-msnmsgrp2p");
 
@@ -250,6 +252,12 @@
 	/* Now we *should* be at the body. */
 	content_type = msn_message_get_content_type(msg);
 
+	if (content_type != NULL &&
+		!strcmp(content_type, "application/x-msnmsgrp2p")) {
+		msg->msnslp_message = TRUE;
+		msg->part = msn_slpmsgpart_new_from_data(tmp, payload_len - (tmp - tmp_base));
+	}
+
 	if (payload_len - (tmp - tmp_base) > 0) {
 		msg->body_len = payload_len - (tmp - tmp_base);
 		g_free(msg->body);
@@ -371,19 +379,26 @@
 
 	body = msn_message_get_bin_data(msg, &body_len);
 
-	if (body != NULL && (end - n) > body_len)
+	if (msg->msnslp_message)
 	{
-		memcpy(n, body, body_len);
-		n += body_len;
-		*n = '\0';
-	}
+		size_t siz;
+		char *body;
 
-	if (ret_size != NULL)
-	{
-		*ret_size = n - base;
+		body = msn_slpmsgpart_serialize(msg->part, &siz);
 
-		if (*ret_size > 1664)
-			*ret_size = 1664;
+		memcpy(n, body, siz);
+		n += siz;
+
+		g_free(body);
+	}
+	else
+	{
+		if (body != NULL)
+		{
+			memcpy(n, body, body_len);
+			n += body_len;
+			*n = '\0';
+		}
 	}
 
 	return base;
@@ -624,23 +639,43 @@
 
 	body = msn_message_get_bin_data(msg, &body_len);
 
-	if (body != NULL)
+	if (msg->msnslp_message)
 	{
-		if (msg->type == MSN_MSG_TEXT)
-		{
-			g_string_append_len(str, body, body_len);
-			g_string_append(str, "\r\n");
-		}
-		else
+		msn_slpmsgpart_to_string(msg->part, str);
+
+		if (purple_debug_is_verbose() && body != NULL)
 		{
-			size_t i;
-			for (i = 0; i < body_len; i++, body++)
+			if (text_body)
+			{
+				g_string_append_len(str, body, body_len);
+				if (body[body_len - 1] == '\0')
+				{
+					str->len--;
+					g_string_append(str, " 0x00");
+				}
+				g_string_append(str, "\r\n");
+			}
+			else
 			{
-				g_string_append_printf(str, "%02x ", (unsigned char)*body);
-				if (i % 16 == 0 && i != 0)
-					g_string_append_c(str, '\n');
+				int i;
+
+				for (i = 0; i < body_len; i++)
+				{
+					g_string_append_printf(str, "%.2hhX ", body[i]);
+					if ((i % 16) == 15)
+						g_string_append(str, "\r\n");
+				}
+
+				g_string_append(str, "\r\n");
 			}
-			g_string_append_c(str, '\n');
+		}
+	}
+	else
+	{
+		if (body != NULL)
+		{
+			g_string_append_len(str, body, body_len);
+			g_string_append(str, "\r\n");
 		}
 	}
 
@@ -819,6 +854,8 @@
 
 }
 
+#define purple_mkstemp(a, b) NULL
+
 /* TODO: Make these not be such duplicates of each other */
 static void
 got_wink_cb(MsnSlpCall *slpcall, const guchar *data, gsize size)
@@ -877,7 +914,6 @@
 {
 	MsnSession *session;
 	MsnSlpLink *slplink;
-	MsnP2PVersion p2p;
 
 	session = cmdproc->servconn->session;
 	slplink = msn_session_get_slplink(session, msg->remote_user);
@@ -900,13 +936,11 @@
 		}
 	}
 
-	p2p = msn_slplink_get_p2p_version(slplink);
-	msg->part = msn_slpmsgpart_new_from_data(p2p, msg->body, msg->body_len);
-
-	if (msg->part)
+	if (msg->part) {
 		msn_slplink_process_msg(slplink, msg->part);
-	else
-		purple_debug_warning("msn", "P2P message failed to parse.\n");
+	}
+	else /* This should never happen. */
+		purple_debug_fatal("msn", "P2P message without a Part.\n");
 }
 
 static void
@@ -947,7 +981,7 @@
 
 	session = cmdproc->servconn->session;
 
-	if (!purple_account_get_bool(session->account, "custom_smileys", TRUE))
+	if (!purple_account_get_bool(session->account, "custom_smileys", FALSE))
 		return;
 
 	swboard = cmdproc->data;
